﻿using System;
using System.Drawing;

namespace Color_Extensions
{
    public static class Extensions
    {
        public static double GetValue(this Color color)
        {
            return Math.Max(Math.Max(color.R, color.G), color.B) / 255.0;
        }
        public static double GetHSLSaturation(this Color color)
        {
            double C = color.GetChroma();
            if (C < 0.00001)
                return 0;
            return C / color.GetValue();
        }
        public static double GetChroma(this Color color)
        {
            int M = Math.Max(Math.Max(color.R, color.G), color.B);
            int m = Math.Min(Math.Min(color.R, color.G), color.B);
            return (M - m) / 255.0;
        }
    }
}
