﻿using System;

namespace GBAFE_Tilesets
{
    class Maybe<T>
    {
        private bool _isNothing;
        private T _value;

        #region Accessors
        public bool IsNothing { get { return _isNothing; } }
        public bool IsSomething { get { return !_isNothing; } }
        public T Value
        {
            get
            {
                if (IsNothing)
                    throw new NotImplementedException();
                return _value;
            }
        }
        #endregion

        /// <summary>
        /// Creates a maybe object representing Nothing.
        /// </summary>
        public Maybe()
        {
            _isNothing = true;
        }
        /// <summary>
        /// Creates a maybe object that is not Nothing.
        /// </summary>
        public Maybe(T value) : this(false, value) { }
        private Maybe(bool nothing, T value)
        {
            _isNothing = nothing;
            _value = value;
        }

        public static implicit operator Maybe<T>(T value)
        {
            return new Maybe<T>(value);
        }
    }
}
